SystemOrganization addCategory: #'Glamour-Tools'!

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'TudorGirba 7/10/2011 01:37'!
viewAnnouncements

	| view |
	
	view := MOViewRenderer new.
	self viewAnnouncementsOn: view.
	view open! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'TudorGirba 7/14/2011 15:37'!
viewAnnouncementsOn: view
	view shape rectangle withoutBorder.
	view node: 'Glamour' forIt: [
		self viewTreeOn: view ].
	view shape umlClassWithTitle: #yourself.
	view node: 'Announced objects' forIt: [
		view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Renderer' ].
		view nodes: 
			(self pane withAllPanes flatCollect: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]]) asSet.
		view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Renderer' ].
		view nodes: 
			(self pane withAllPresentations flatCollect: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]]) asIdentitySet.
		view verticalLineLayout ].
	
	view shape line 
			color: Color red twiceLighter;
			fromPositions: #(rightCenter);
			toPositions: #(leftCenter).
	view edges: self pane withAllPanes from: #yourself toAll: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]].
	view shape line 
			color: Color red twiceLighter;
			fromPositions: #(rightCenter);
			toPositions: #(leftCenter).
	view edges: self pane withAllPresentations from: #yourself toAll: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]].
	view horizontalLineLayout horizontalGap: 50! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'TudorGirba 7/10/2011 00:50'!
viewNestedOn: view
	view shape umlClassWithTitle: #name.
	view nodes: self panes forEach: [:each |
		view node: each ports forIt: [
			view shape label text: #name.
			view nodes: each ports.
			view verticalLineLayout gapSize: 2 ].
		view node: each presentations forIt: [
			view shape umlClassWithTitle: [:eachPresentation | eachPresentation class name removePrefix: 'GLM'].
	"		view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Presentation' ]."
			each presentations presentations do: [:eachPresentation | 
				eachPresentation viewNestedOn: view ].
			view verticalLineLayout gapSize: 2 ].
		view verticalLineLayout gapSize: 0; stretch ].
	view 
		edges: self transmissions 
		fromAll: #origins
		to: #destination! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'TudorGirba 7/10/2011 01:14'!
viewTree

	| view |
	
	view := MOViewRenderer new.
	self viewTreeOn: view.
	view open! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'TudorGirba 7/10/2011 12:16'!
viewTreeOn: view
	| edges1 edges2 edges3 edges4 |
	
	view shape umlClassWithTitle: #name.
	view nodes: self pane withAllPanes forEach: [ :each |
		view shape label text: #name.
		view nodes: each ports.
		view verticalLineLayout gapSize: 2 ].
	
	view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Presentation' ].
	view nodes: self pane withAllPresentations.

	view shape verticalOrthogonalLine color: Color lightGray. 	
	edges1 := view edges: self pane withAllPanes from: #yourself to: [:each | each presentations ].

	view shape verticalOrthogonalLine color: Color lightGray. 
	edges2 := view edges: self pane withAllPanes from: #browser to: #yourself.

	view shape verticalOrthogonalLine color: Color lightGray. 
	edges3 := view edges: (self pane withAllPresentations select: [:each | each isKindOf: GLMDynamicPresentation]) from: #yourself to: #cachedPresentation.

	view shape verticalOrthogonalLine color: Color lightGray.
	edges4 := view edges: (self pane withAllPresentations select: [:each | each isKindOf: GLMCompositePresentation]) from: #yourself toAll: #presentations.


	view treeLayout layered userDefinedEdges: (edges1, edges2, edges3, edges4).

	view shape line color: Color blue. 
	view 
		edges: ((self pane withAllPresentations select: [:each | each isKindOf: GLMBrowser]) flatCollect: [:each | each transmissions])
		fromAll: #origins
		to: #destination.
		view shape line color: Color blue
! !

!GLMPresentation methodsFor: '*glamour-tools' stamp: 'TudorGirba 7/10/2011 00:50'!
viewNestedOn: view
	view shape label text: [:each | each class name removePrefix: 'GLM'].
	view node: self! !

Object subclass: #GLMBrowserTemplate
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMBrowserTemplate classSide methodsFor: 'opening' stamp: 'tg 12/29/2009 03:33'!
openOn: anEntity
	^ self new openOn: anEntity! !

!GLMBrowserTemplate classSide methodsFor: 'opening' stamp: 'tg 1/15/2010 23:46'!
startOn: anEntity
	^ self new startOn: anEntity! !

!GLMBrowserTemplate methodsFor: 'accessing' stamp: 'tg 12/29/2009 03:41'!
browser
	^ browser ifNil: [self buildBrowser. browser]! !

!GLMBrowserTemplate methodsFor: 'building' stamp: 'tg 12/15/2009 13:54'!
buildBrowser
	^ self subclassResponsibility! !

!GLMBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:30'!
openOn: anEntity
	^ self browser openOn: anEntity! !

!GLMBrowserTemplate methodsFor: 'opening' stamp: 'tg 1/15/2010 23:31'!
startOn: anEntity
	^ self browser startOn: anEntity! !

GLMBrowserTemplate subclass: #GLMEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMEditor commentStamp: 'TudorGirba 7/15/2011 12:52' prior: 0!
self openOn: '| browser |
browser := GLMTabulator new.
browser startOn: 42'!

!GLMEditor methodsFor: 'building' stamp: 'TudorGirba 7/15/2011 12:51'!
buildBrowser
	browser := GLMTabulator new.
	browser row: #browser; row: #source.
	browser title: 'Glamour Browser Editor'.
	browser transmit to: #source; andShow: [ :a |
		a text
			title: 'Editor';
			forSmalltalk;
			populate: #selection icon: GLMUIThemeExtraIcons glamorousAccept on: $s entitled: 'Open (s)' with: [:text | text text]].
	browser transmit to: #browser; from: #source; andShow: [ :a |
		a dynamic
			title: 'Preview';
			display: [:source | 
				(Compiler evaluate: source logged: false)]].
	^ browser! !

GLMBrowserTemplate subclass: #GLMGlobalBrowserTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMGlobalBrowserTemplate classSide methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
open
	^ self new
		open! !

!GLMGlobalBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
entity
	^ self subclassResponsibility! !

!GLMGlobalBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
open
	^ self openOn: self entity! !

GLMBrowserTemplate subclass: #GLMMondrianEasel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMMondrianEasel commentStamp: 'TudorGirba 7/15/2011 10:24' prior: 0!
self openOn: 'view shape label.
view nodes: (1 to: 40).
view edgesFrom: [:x | x // 3 ].
view treeLayout'!

!GLMMondrianEasel methodsFor: 'building' stamp: 'TudorGirba 7/15/2011 10:24'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Simple Mondrian Easel'.
	browser row: #painting span: 10; row: #script span: 4.
	browser transmit to: #script; andShow: [ :a |
		a text
			forSmalltalk;
			variableBindings: [:script | {#view -> MOViewRenderer new}];
			title: 'Mondrian script';
			display: [:script | script ];
			populate: #selection icon: GLMUIThemeExtraIcons glamorousAccept on: $s entitled: 'Generate View' with: [:text | text text ] ].
	browser transmit to: #painting; from: #script; andShow: [ :a |
		a mondrian
			title: 'Mondrian painting';
			painting: [ :view :script | 
						(Compiler evaluate: '| view | view := self.', script for: view logged: false) ];
			act: [:m | m canvas exportAsPNG] entitled: 'Export as PNG';
			act: [:m | 
				m canvas root decreaseZoom.
				m canvas  changed ] 
			icon: MondrianIcons mondrianZoomOut
			entitled: 'Zoom out';
			act: [:m | 
				m canvas root increaseZoom.
				m canvas root updateWindow ] 
			icon: MondrianIcons mondrianZoomIn 
			entitled: 'Zoom in'].
	^ browser! !

Object subclass: #GLMOBCommandAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMOBCommandAdaptor methodsFor: 'as yet unclassified' stamp: 'tg 9/25/2010 17:55'!
actionsFrom: aCollectionOfOBCommandClasses on: aTarget for: aRequestor
	^ (aCollectionOfOBCommandClasses "select: [ :each | each isActive ]") collect: [ :each |
		| command |
		command := each on: aTarget for: aRequestor.
		GLMGenericAction new
			icon: command icon;
			title: command label;
			action: [:presentation | command execute ];
			yourself 
		]! !
